'FFSubmenu=Tools
'FFName=Gitter

'(c) Harald Maeckler, Dsseldorf 2009

' ********************************************************************
' Gitter.vbs (Script fr FixFoto)
' Funktion:	Gitter eintragen
'			- Abstand, strichstrke und Farbe whlbar
'
' Version 1.01 vom 08.07.2009	- Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 1.00 vom 03.02.2009	- Betaversion
'  
'** Start Kurzbeschreibung *******************************************
' Gitter / Version 1.01
' ============
' Das Skript dient der Erzeugung eines Gitters auf dem Bild, das sich auf der Arbeits-
' flche von FixFoto befindet.
'
' Vorgaben
' ------------
' Der horizontale und vertikale Abstand der Gitterlinien ist als Promillewert der lngsten
' Seite des Bildes eingebbar. Wird "Abstand gleich" aktiviert, wird der horizontale Abstand
' auch fr den vertikalen verwendet.
'
' Die Strichstrke wird in Pixel eingegeben. Die Farbe ist frei bestimmbar.
'
' Mit "Gitter zeichnen" werden die aktuellen Vorgaben gesichert und bei erneutem Skriptauf-
' ruf wieder eingetragen.
'
' Gitter zeichnen
' ------------------
' Mit dem Befehl "Gitter zeichnen" wird das Gitter erstellt und das Skript beendet. Lschen
' kann man das Gitter mit "Bearbeiten/Rckgngig" bzw. der Tastenkombination Strg + Z.
'
' Abbruch
' ----------
' Das Skript kann durch Mausklick auf das Kreuz rechts oben oder durch Bettigung von ESCAPE
' vorzeitig abgebrochen werden.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten,
' davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach werden nach-
' einander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle Zusatz-
' dateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

Dim Breite,Hoehe,Faktor,SkriptKill,Antwort,TempFile
Dim AbstdH,AbstdV,LinSt,LinFarbe,Gleich

const SkriptName = "Gitter.vbs"								'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim objFS,WshShell											'Objekte

'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm

'Vorspann
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	Breite=FF_GetImageWidth()	'Breite
 	if Err.Number = 500 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if Breite = 0 then
	msgbox "Kein Bild geladen oder markiert!",vbCritical,"Abbruch"
	exit sub
end if

Hoehe=FF_GetImageHeight()		'Hhe
if Breite > Hoehe then
	Faktor = Breite/1000		'Faktor fr Umrechnung Promille zu Pixel
else
	Faktor = Hoehe/1000
end if

'** Start Dialog Gitter **
FF_AddDialog "Gitter",182,95
FF_AddControl "Gitter","Vorgaben","GROUP",10,10,162,60
FF_AddControl "Gitter","Abstand horizontal","STATIC",15,20,50,11
FF_AddControl "Gitter","AbstdH","SLEDIT",63,21,20,10
FF_SetControlStyle "Gitter","AbstdH",8194
FF_AddControl "Gitter","","STATIC",85,20,11,11
FF_AddControl "Gitter","Abstand vertikal","STATIC",15,32,50,11
FF_AddControl "Gitter","AbstdV","SLEDIT",63,32,20,10
FF_SetControlStyle "Gitter","AbstdV",8194
FF_AddControl "Gitter","|","STATIC",85,31,11,11
FF_AddControl "Gitter","Abstand gleich","STATIC",105,27,37,11
FF_AddControl "Gitter","AbstdGleich","BOOL",145,29,8,8
FF_SetControlStyle "Gitter","AbstdGleich",16384
FF_AddControl "Gitter","Linienstrke","STATIC",15,54,50,11
FF_AddControl "Gitter","LinSt","SLEDIT",63,54,20,10
FF_SetControlStyle "Gitter","LinSt",8194
FF_AddControl "Gitter","px","STATIC",85,54,11,11
FF_AddControl "Gitter","Linienfarbe","STATIC",105,54,29,11
FF_AddControl "Gitter","LinFarbe","COLOR",135,54,33,10
FF_AddControl "Gitter","?","BUTTON",15,77,11,11
FF_AddControl "Gitter","Gitter zeichnen","BUTTON",128,77,40,11
FF_AddControl "Gitter","&d","BUTTON",70,80,1,1
'** End Dialog Gitter **

call RegistryLesen

FF_ActivateControl "Gitter","&d"

do									'Befehlsabfrage
	Select Case FF_ShowDialog ("Gitter")
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	case "AbstdGleich"
		if FF_GetControl("Gitter","AbstdGleich") = "1" then
			FF_EnableControl "Gitter","AbstdV",False
		else
			FF_EnableControl "Gitter","AbstdV",True
		end if
	Case "?"
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	Case "Gitter zeichnen"
		call RegistrySchreiben
		call Zeichnen
		exit do
	Case "CANCEL"
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Gitter")
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'------------------------------------------------------------------------
Sub Zeichnen
Dim Wert,xstart,ystart,xend,yend

'FF_Line(VT_I4 xstart, VT_I4 ystart, VT_I4 xend, VT_I4 yend, VT_I4 colorref, VT_I4 width)
'
'Beschreibung
'------------
'Zeichnet eine Linie variabler Farbe und Strke.
'
'Argumente
'---------
'xstart = Startpunkt von links (in px)
'ystart = Startpunkt von oben (in px)
'xend = Endpunkt von links (in px)
'yend = Endpunkt von oben (in px)
'colorref = Farbe der Linie
'width = Breite der Linie

call WerteAuslesen

Wert = 0 : xstart = 0 : xend = Breite
do											'horizontale Linien
	ystart = Wert
	yend = ystart
	if ystart > Hoehe then exit do
	call FF_Line (xstart,ystart,xend,yend,LinFarbe,LinSt)
	Wert = Wert + AbstdH
loop

Wert = 0 : ystart = 0 : yend = Hoehe
do											'vertikale Linien
	xstart = Wert
	xend = xstart
	if xstart > Breite then exit do
	call FF_Line (xstart,ystart,xend,yend,LinFarbe,LinSt)
	Wert = Wert + AbstdV
loop

FF_Reload()

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen
Dim Farbe,Rot,Gruen,Blau

AbstdH = Cint(FF_GetControl("Gitter","AbstdH") * Faktor)
if FF_GetControl("Gitter","AbstdGleich") = "1" then
	Gleich = True
	AbstdV = AbstdH
else
	Gleich = False
	AbstdV = Cint(FF_GetControl("Gitter","AbstdV") * Faktor)
end if

LinSt = FF_GetControl("Gitter","LinSt")

LinFarbe = FF_GetControl("Gitter","LinFarbe")	'Umwandlung in colorref
Farbe = split(LinFarbe," ")
Rot = Farbe(0) * 1
Gruen = Farbe(1) * 1
Blau = Farbe(2) * 1
LinFarbe = Rot + Gruen * (2^8) + Blau * (2^16)

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Gitter

'Werte auslesen
AbstdV = FF_GetProfile("FF_Gitter","AbstdV")
if AbstdV = "" then AbstdV = 40
AbstdH = FF_GetProfile("FF_Gitter","AbstdH")
if AbstdH = "" then AbstdH = 40
Gleich = FF_GetProfile("FF_Gitter","Gleich")
if Gleich = "" then Gleich = False
LinSt  = FF_GetProfile("FF_Gitter","LinSt")
if LinSt = "" then LinSt = 3
LinFarbe = FF_GetProfile("FF_Gitter","LinFarbe")
if LinFarbe = "" then LinFarbe = "000 000 000"

'Werte eintragen
FF_SetControl "Gitter","AbstdV",AbstdV
FF_SetControl "Gitter","AbstdH",AbstdH
if Gleich then
	FF_SetControl "Gitter","AbstdGleich","1"
	FF_EnableControl "Gitter","AbstdV",False
else
	FF_SetControl "Gitter","AbstdGleich","0"
	FF_EnableControl "Gitter","AbstdV",True
end if
FF_SetControl "Gitter","LinSt",LinSt
FF_SetControl "Gitter","LinFarbe",LinFarbe

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Gitter

'Werte auslesen
call WerteAuslesen
AbstdV = FF_GetControl("Gitter","AbstdV")
AbstdH = FF_GetControl("Gitter","AbstdH")
LinFarbe = FF_GetControl("Gitter","LinFarbe")

'Werte eintragen
FF_WriteProfile "FF_Gitter","AbstdV",AbstdV
FF_WriteProfile "FF_Gitter","AbstdH",AbstdH
if Gleich then
	FF_WriteProfile "FF_Gitter","Gleich",True
else
	FF_WriteProfile "FF_Gitter","Gleich",False
end if
FF_WriteProfile "FF_Gitter","LinSt",LinSt
FF_WriteProfile "FF_Gitter","LinFarbe",LinFarbe

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_Gitter\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"	'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------